# IMFPart Struct Reference
[MCFrame]

Inheritance diagram for IMFPart:

List of all members.

## Public Member Functions
virtual boolean MCCOMAPI | SetWantsToValidateCaches ()=0
virtual void MCCOMAPI | SelfDraw (IMCGraphicContext *inGraphicContext, const TMCRect &inUpdateBBox)=0
virtual TMFEventResult MCCOMAPI | SelfMouseDown (const TMCPoint &inWhere, const TMCPlatformEvent &inEvent)=0
virtual void MCCOMAPI | Enable (boolean beEnabled)=0
virtual void MCCOMAPI | Invalidate ()=0
virtual void MCCOMAPI | Invalidate (const TMCRect &invalRect)=0
virtual void MCCOMAPI | ProcessUpdates (const TMCRect &inUpdateRect=TMCRect::kInvalid)=0
virtual void MCCOMAPI | ProcessUpdatesPart (boolean inPostAction=false)=0
virtual MCCOMErr MCCOMAPI | FindChildPartByID (IMFPart **outPart, uint32 inPartID, boolean inStopAtGroup=false) const =0
virtual void MCCOMAPI | FindChildParts (const TMCArray< TPartFindingInfo > &inPartArray) const =0
virtual void MCCOMAPI | AddChildIMFPart (IMFPart *inPart)=0
virtual void MCCOMAPI | RemoveFromParent ()=0
virtual void MCCOMAPI | GetChildParts (TMCCountedPtrArray< IMFPart > &children) const =0
virtual SystWindowPtr MCCOMAPI | GetSystemWindowPtr ()=0
virtual void MCCOMAPI | GetNonBufferedGraphicContext (IMCGraphicContext **outContext)=0
virtual IMFPart *MCCOMAPI | GetPartParent () const =0
virtual MCCOMErr MCCOMAPI | GetPartParent (IMFPart **outPart) const =0
virtual MCCOMErr MCCOMAPI | GetPartParentWindow (IMFPart **outPart)=0
virtual MCCOMErr MCCOMAPI | GetPartBaseWindow (IMFPart **outPart)=0
virtual IMFWindow *MCCOMAPI | GetPartBaseWindowNoAddRef ()=0
virtual void MCCOMAPI | GetSize (TMCPoint &ioSize) const =0
virtual IDType MCCOMAPI | GetIMFPartID (void) const =0
virtual boolean MCCOMAPI | GetActive (void) const =0
virtual void MCCOMAPI | GetPositionInWindow (TMCPoint &ioPosition) const =0
virtual void MCCOMAPI | GetPositionInParent (TMCPoint &ioPosition) const =0
virtual void MCCOMAPI | GetPositionInLocal (TMCPoint &ioPosition) const =0
virtual void MCCOMAPI | GetBoundsInParent (TMCRect &ioBounds) const =0
virtual void MCCOMAPI | GetBoundsInWindow (TMCRect &ioBounds) const =0
virtual void MCCOMAPI | GetBoundsInLocal (TMCRect &ioBounds) const =0
virtual void MCCOMAPI | GetClipBoundsInLocal (TMCRect &ioBounds) const =0
virtual void MCCOMAPI | GetClipBoundsInParent (TMCRect &ioBounds) const =0
virtual void MCCOMAPI | GetClipBoundsInWindow (TMCRect &ioBounds) const =0
virtual void MCCOMAPI | GetChildPartsBounds (TMCRect &outBounds) const =0
virtual void MCCOMAPI | SetSize (const TMCPoint &inSize, boolean inInvalidate, boolean inNotify)=0
virtual void MCCOMAPI | SetPositionInParent (const TMCPoint &inPosition, boolean inInvalidate, boolean inNotify)=0
virtual void MCCOMAPI | SetBoundsInParent (const TMCRect &inBounds, boolean invalidate=true, boolean notify=false)=0
virtual void MCCOMAPI | SwapOrientation (boolean inHorizontal)=0
virtual void MCCOMAPI | GetValue (void *outValue, MFPartValueType inValueType) const =0
virtual void MCCOMAPI | SetValue (const void *inValue, MFPartValueType inValueType, boolean inInvalidate, boolean inNotify)=0
virtual void MCCOMAPI | SetShown (boolean inShown, boolean setChilds=false)=0
virtual boolean MCCOMAPI | IsShowing () const =0
virtual void MCCOMAPI | SetPartID (MFPartID inPartID)=0
virtual void MCCOMAPI | SetCursorID (MFCursorID inCursorID)=0
virtual void MCCOMAPI | SetCursor (MFCursorID inCursorID)=0
virtual void MCCOMAPI | SetEraseBack (boolean inEraseBack)=0
virtual void MCCOMAPI | SetMustFullyInvalidate (boolean inMust)=0
virtual void MCCOMAPI | SetExcludeFromDoubleBuffer (boolean inExclude)=0
virtual void MCCOMAPI | SetWantsVisibleRegion (boolean inWantsVisibleRegion)=0
virtual void MCCOMAPI | SelfMouseEntering (const TMCPoint &inWhere, const TMCModifiers &inModifiers)=0
virtual void MCCOMAPI | SelfMouseStillInside (const TMCPoint &inWhere, const TMCModifiers &inModifiers)=0
virtual void MCCOMAPI | SelfMouseLeaving (const TMCModifiers &inModifiers)=0
virtual void MCCOMAPI | SelfTrackDragAndDropEntering (const TMCPoint &inWhere, const TMFDragFlavors &inOfferedTypeList)=0
virtual void MCCOMAPI | SelfTrackDragAndDropStillInside (const TMCPoint &inWhere, const TMFDragFlavors &inOfferedTypeList)=0
virtual void MCCOMAPI | SelfTrackDragAndDropLeaving (const TMFDragFlavors &inOfferedTypeList)=0
virtual void MCCOMAPI | BindGraphicContext (IMCGraphicContext *drawContext=nil)=0
virtual void MCCOMAPI | BindNonBufferedGraphicContext (IMCGraphicContext *drawContext)=0
virtual void MCCOMAPI | ClipContextToPart (IMCGraphicContext *drawContext=nil)=0
virtual TMCArray< TMCRect > *MCCOMAPI | GetVisibleRectsInWindow (boolean fullyVisibleOnly=true)=0
virtual void MCCOMAPI | ImmediateUpdate (boolean useDoubleBuffer=false, const TMCRect *inBounds=nil)=0
virtual void MCCOMAPI | CallPrepareToDestroy ()=0
virtual void MCCOMAPI | LocalToParent (TMCPoint &ioParentPoint) const =0
virtual void MCCOMAPI | LocalToParent (TMCRect &ioParentRect) const =0
virtual void MCCOMAPI | LocalToWindow (TMCPoint &ioWindowPoint) const =0
virtual void MCCOMAPI | LocalToWindow (TMCRect &ioWindowRect) const =0
virtual void MCCOMAPI | LocalToBaseWindow (TMCPoint &ioWindowPoint) const =0
virtual void MCCOMAPI | LocalToBaseWindow (TMCRect &ioWindowRect) const =0
virtual void MCCOMAPI | LocalToScreen (TMCPoint &ioWindowPoint) const =0
virtual void MCCOMAPI | LocalToScreen (TMCRect &ioWindowRect) const =0
virtual void MCCOMAPI | ParentToLocal (TMCPoint &ioParentPoint) const =0
virtual void MCCOMAPI | ParentToLocal (TMCRect &ioParentRect) const =0
virtual void MCCOMAPI | WindowToLocal (TMCPoint &ioWindowPoint) const =0
virtual void MCCOMAPI | WindowToLocal (TMCRect &ioWindowRect) const =0
virtual void MCCOMAPI | BaseWindowToLocal (TMCPoint &ioWindowPoint) const =0
virtual void MCCOMAPI | BaseWindowToLocal (TMCRect &ioWindowRect) const =0
virtual void MCCOMAPI | ScreenToLocal (TMCPoint &ioWindowPoint) const =0
virtual void MCCOMAPI | ScreenToLocal (TMCRect &ioWindowRect) const =0
virtual void MCCOMAPI | SetIsOpaque (boolean isOpaque)=0
virtual void MCCOMAPI | SetTextStyle (ETextStyle inTextStyle, const TMCString &inFontName, uint16 inSize, uint16 inFace)=0
virtual void MCCOMAPI | GetTextStyle (ETextStyle &outTextStyle, TMCString &outFontName, uint16 &outSize, uint16 &outFace)=0
virtual const TMCString *MCCOMAPI | GetWebLink () const =0
virtual void MCCOMAPI | SetWebLink (const TMCString &inLink)=0
virtual void MCCOMAPI | SetIMFPartID (IDType partID)=0
virtual void MCCOMAPI | SetAttribute (const IMFAttribute &inAttribute)=0
virtual void MCCOMAPI | GetAttribute (IMFAttribute &outAttribute)=0
virtual void MCCOMAPI | ResignAsResponder ()=0
virtual SystemGCPtr MCCOMAPI | GetSystemDeviceContextPtr (void)=0
virtual IMFPart *MCCOMAPI | FindParentPartByID (uint32 inPartID) const =0
virtual TComponentClass *MCCOMAPI | GetCursorID (const TMCPoint &inWhere, MFCursorID &outCursorID) const =0
virtual IMFResponder *MCCOMAPI | GetThisResponder ()=0
virtual IMFPart *MCCOMAPI | FindChildPartByID (IDType inPartID, boolean inStopAtGroup=false) const =0
virtual void MCCOMAPI | SetOpacityKind (EOpacityKind inOpacityKind)=0
virtual boolean MCCOMAPI | IsChildOf (const IMFPart *inPart) const =0
virtual void MCCOMAPI | SetIsGroup (boolean isGroup)=0
| Sets whether this part is a group or not.
virtual boolean MCCOMAPI | GetIsGroup () const =0
| Gets whether this part is a group or not.
virtual IMFPart *MCCOMAPI | GetParentGroup () const =0
| Gets the first group containing this part (going up), returns null is there's none.
virtual void MCCOMAPI | SetMultiValueMode (boolean activateMultiValueMode)=0
virtual boolean MCCOMAPI | IsInMultiValueMode () const =0
| Returns true if the multiple values mode is on.
virtual boolean MCCOMAPI | IsValueUndefined () const =0
| Returns true when the multiple values mode is on and different values have been set.
virtual void MCCOMAPI | UndefineValue ()=0
| Activates multivalue mode if needed and marks the value as undefined.
virtual void MCCOMAPI | BeginSetMultiValues ()=0
virtual void MCCOMAPI | EndSetMultiValues (MFPartValueType inValueType)=0
virtual void MCCOMAPI | SetToolTipString (const TMCString &str)=0

## Detailed Description

A Part is the basic element from which MCFrame user interfaces are built. They draw themselves and handle user interaction. Generally all useful Parts will implement another more specialized interface as well as the IMFPart interface.

Parts are organized in a tree structure, with children considered to be inside their parent.

## Member Function Documentation

virtual void MCCOMAPI IMFPart::AddChildIMFPart | ( | IMFPart * | inPart | ) | `[pure virtual]`

Adds a Part as a child of this Part.

Parameters:

  | inPart | The Part to add as a child

virtual void MCCOMAPI IMFPart::BaseWindowToLocal | ( | TMCRect & | ioWindowRect | ) | const`[pure virtual]`

Converts a TMCRect from base window to local coordinate space

Parameters:

  | ioWindowRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::BaseWindowToLocal | ( | TMCPoint & | ioWindowPoint | ) | const`[pure virtual]`

Converts a TMCPoint from base window to local coordinate space

Parameters:

  | ioWindowPoint | The point to be converted

virtual void MCCOMAPI IMFPart::BeginSetMultiValues | ( |  | ) | `[pure virtual]`

When the part is in multiple values mode, this must be called before repeated calls to SetValue

virtual void MCCOMAPI IMFPart::BindGraphicContext | ( | IMCGraphicContext * | drawContext = `nil` | ) | `[pure virtual]`

Sets up the passed-in graphic context to operate within the Part.

Parameters:

  | drawContext | The graphic context to bind to

virtual void MCCOMAPI IMFPart::BindNonBufferedGraphicContext | ( | IMCGraphicContext * | drawContext | ) | `[pure virtual]`

Same as BindGraphicContext but specific to Non Buffered Graphic Context.

Parameters:

  | drawContext | The graphic context to bind to (Should not be NULL)

virtual void MCCOMAPI IMFPart::CallPrepareToDestroy | ( |  | ) | `[pure virtual]`

Call this function before destroying a Part, either manually or by letting its refcount go to 0. It unregisters the Part as a responder and otherwise unhooks it from the UI.

virtual void MCCOMAPI IMFPart::ClipContextToPart | ( | IMCGraphicContext * | drawContext = `nil` | ) | `[pure virtual]`

Clips the passed-in graphic context to this Part's bounds. If no context is passed in, expands clip area of the view's current graphic context to enclose the view's clip rectangle. (See GetClipBoundsInWindow)

Parameters:

  | drawContext | The graphic context to clip

virtual void MCCOMAPI IMFPart::Enable | ( | boolean | beEnabled | ) | `[pure virtual]`

Sets the enabled state of the Part.

Parameters:

  | beEnabled | should the part be enabled?

virtual void MCCOMAPI IMFPart::EndSetMultiValues | ( | MFPartValueType | inValueType | ) | `[pure virtual]`

When the part is in multiple values mode, this must be called after repeated calls to SetValue (with the same type !)

virtual IMFPart* MCCOMAPI IMFPart::FindChildPartByID | ( | IDType | inPartID,
|  | boolean | inStopAtGroup = `false` |
| ) |  |  | const`[pure virtual]`

Finds a child Part of the current Part by ID, and returns it without incrementing the child's refcount.

Parameters:

  | inPartID | The ID to search for
  | inStopAtGroup | If true, the search will not go through group parts.

Returns:
  A pointer to the resulting child Part, or NULL if no child Part with that ID exists.

virtual MCCOMErr MCCOMAPI IMFPart::FindChildPartByID | ( | IMFPart ** | outPart,
|  | uint32 | inPartID,
|  | boolean | inStopAtGroup = `false` |
| ) |  |  | const`[pure virtual]`

Locates a child Part of this Part by its ID value, if it exists.

Parameters:

  | outPart | Returns a pointer to the child Part, or NULL if the child doesn't exist.
  | inPartID | ID of the child Part to find.
  | inStopAtGroup | If true, the search will not go through group parts.

Returns:
  MC_S_OK

virtual void MCCOMAPI IMFPart::FindChildParts | ( | const TMCArray< TPartFindingInfo > & | inPartArray | ) | const`[pure virtual]`

Finds several child parts at the same time

Parameters:

  | inPartArray | the info about the child parts we want to find

See also:
  TPartFindingInfo

virtual IMFPart* MCCOMAPI IMFPart::FindParentPartByID | ( | uint32 | inPartID | ) | const`[pure virtual]`

Searches the hierarchy of Parts upwards from this Part, looking for a parent Part with a given ID.

Parameters:

  | inPartID | The ID of the parent Part to find

Returns:
  A pointer to the parent Part, or NULL if no parent has the specified ID

virtual boolean MCCOMAPI IMFPart::GetActive | ( | void |  | ) | const`[pure virtual]`

Returns:
  True if the window containing this part is active.

virtual void MCCOMAPI IMFPart::GetAttribute | ( | IMFAttribute & | outAttribute | ) | `[pure virtual]`

Gets the Attribute of the Part. This is used to get several properties of the Part, with some type checking. Note: This is currently only implemented by slider parts.

See also:
  IMFAttribute

Parameters:

  | outAttribute | Returns the IMFAttribute from the Part

virtual void MCCOMAPI IMFPart::GetBoundsInLocal | ( | TMCRect & | ioBounds | ) | const`[pure virtual]`

Returns the bounds of the Part in local coordinate space.

Parameters:

  | ioBounds | Returns the bounds as a TMCRect

virtual void MCCOMAPI IMFPart::GetBoundsInParent | ( | TMCRect & | ioBounds | ) | const`[pure virtual]`

Returns the bounds of the Part in parent coordinate space.

Parameters:

  | ioBounds | Returns the bounds as a TMCRect

virtual void MCCOMAPI IMFPart::GetBoundsInWindow | ( | TMCRect & | ioBounds | ) | const`[pure virtual]`

Returns the bounds of the part in window coordinate space.

Parameters:

  | ioBounds | Returns the bounds as a TMCRect

virtual void MCCOMAPI IMFPart::GetChildParts | ( | TMCCountedPtrArray< IMFPart > & | children | ) | const`[pure virtual]`

Fills an array with the child parts.

virtual void MCCOMAPI IMFPart::GetChildPartsBounds | ( | TMCRect & | outBounds | ) | const`[pure virtual]`

Get the rectangle that bounds all of this Part's child Parts, in coordinates local to this Part

Parameters:

  | outBounds | Returns the bounds as a TMCRect

virtual void MCCOMAPI IMFPart::GetClipBoundsInLocal | ( | TMCRect & | ioBounds | ) | const`[pure virtual]`

Returns the Part clipping bounds in local coordinate space.

Parameters:

  | ioBounds | Returns the bounds as a TMCRect

virtual void MCCOMAPI IMFPart::GetClipBoundsInParent | ( | TMCRect & | ioBounds | ) | const`[pure virtual]`

Returns the Part clipping bounds in parent coordinate space.

Parameters:

  | ioBounds | Returns the bounds as a TMCRect

virtual void MCCOMAPI IMFPart::GetClipBoundsInWindow | ( | TMCRect & | ioBounds | ) | const`[pure virtual]`

Returns the Part clipping bounds in window coordinate space.

Parameters:

  | ioBounds | Returns the bounds as a TMCRect

virtual TComponentClass* MCCOMAPI IMFPart::GetCursorID | ( | const TMCPoint & | inWhere,
|  | MFCursorID & | outCursorID |
| ) |  |  | const`[pure virtual]`

Returns the Identifier of the cursor that should be used when the mouse pointer is over the part.

Parameters:

  | inWhere | The position of the mouse cursor.
  | outCursorID | the Identifier of the cursor

Returns:
  a pointer to the component class the app needs to use in order to load the cursor's resource (very rarely needed). Returning null will use this (IMFExPart) resources.

virtual IDType MCCOMAPI IMFPart::GetIMFPartID | ( | void |  | ) | const`[pure virtual]`

Accessor for this Part's ID

Returns:
  The Part's ID.

virtual boolean MCCOMAPI IMFPart::GetIsGroup | ( |  | ) | const`[pure virtual]`

Gets whether this part is a group or not.

virtual void MCCOMAPI IMFPart::GetNonBufferedGraphicContext | ( | IMCGraphicContext ** | outContext | ) | `[pure virtual]`

Gets a pointer to the Graphic Context to be used to draw in this Part's system window.

Parameters:

  | outContext | Ends up pointing to the Graphic Context.

virtual IMFPart* MCCOMAPI IMFPart::GetParentGroup | ( |  | ) | const`[pure virtual]`

Gets the first group containing this part (going up), returns null is there's none.

virtual MCCOMErr MCCOMAPI IMFPart::GetPartBaseWindow | ( | IMFPart ** | outPart | ) | `[pure virtual]`

Gets the window containing this Part.

Parameters:

  | outPart | Returns a pointer to the window.

virtual IMFWindow* MCCOMAPI IMFPart::GetPartBaseWindowNoAddRef | ( |  | ) | `[pure virtual]`

Gets the window containing this Part without increasing the window's reference count.

Returns:
  A pointer to the Window.

virtual MCCOMErr MCCOMAPI IMFPart::GetPartParent | ( | IMFPart ** | outPart | ) | const`[pure virtual]`

Parameters:

  | outPart | Returns a pointer to the parent Part.

virtual IMFPart* MCCOMAPI IMFPart::GetPartParent | ( |  | ) | const`[pure virtual]`

Returns:
  A pointer to the parent Part.

virtual MCCOMErr MCCOMAPI IMFPart::GetPartParentWindow | ( | IMFPart ** | outPart | ) | `[pure virtual]`

Gets the topmost window (will be the desktop window in a windoid based system)

Parameters:

  | outPart | Returns a pointer to the window.

virtual void MCCOMAPI IMFPart::GetPositionInLocal | ( | TMCPoint & | ioPosition | ) | const`[pure virtual]`

Returns the postion of the Part in local coordinate space.

Parameters:

  | ioPosition | Returns the position as a TMCPoint

virtual void MCCOMAPI IMFPart::GetPositionInParent | ( | TMCPoint & | ioPosition | ) | const`[pure virtual]`

Returns the postion of the Part in parent coordinate space.

Parameters:

  | ioPosition | Returns the position as a TMCPoint

virtual void MCCOMAPI IMFPart::GetPositionInWindow | ( | TMCPoint & | ioPosition | ) | const`[pure virtual]`

Returns the postion of the Part in window coordinate space.

Parameters:

  | ioPosition | Returns the position as a TMCPoint

virtual void MCCOMAPI IMFPart::GetSize | ( | TMCPoint & | ioSize | ) | const`[pure virtual]`

Accessor for the size of a given Part in pixels.

Parameters:

  | ioSize | Returns a TMCPoint whose x coordinate is the width and whose y coordinate is the height of this Part.

virtual SystemGCPtr MCCOMAPI IMFPart::GetSystemDeviceContextPtr | ( | void |  | ) | `[pure virtual]`

Returns the device context associated with the window returned by GetSystemWindowPtr()

Returns:
  A pointer to the system graphic device context

virtual SystWindowPtr MCCOMAPI IMFPart::GetSystemWindowPtr | ( |  | ) | `[pure virtual]`

Returns:
  A pointer to the System Window that contains this Part.

virtual void MCCOMAPI IMFPart::GetTextStyle | ( | ETextStyle & | outTextStyle,
|  | TMCString & | outFontName,
|  | uint16 & | outSize,
|  | uint16 & | outFace |
| ) |  |  | `[pure virtual]`

Gets the Part's text style.

See also:
  SetTextStyle

Parameters:

  | outTextStyle | Returns the ETextStyle used for the Part
  | outFontName | Returns the name of the font used
  | outSize | Returns the point size of the font used
  | outFace | Returns the style of the font used.

virtual IMFResponder* MCCOMAPI IMFPart::GetThisResponder | ( |  | ) | `[pure virtual]`

A Part is always a Responder, so this method returns a pointer to the IMFResponder interface of the Part.

Returns:
  A pointer to the IMFResponder interface of the Part

virtual void MCCOMAPI IMFPart::GetValue | ( | void * | outValue,
|  | MFPartValueType | inValueType |
| ) |  |  | const`[pure virtual]`

GetValue is used to access a value associated with the Part. It does not free resources if outValue contains a previous value.

Parameters:

  | outValue | Returns a pointer to the value
  | inValueType | Specifies which type of value to access (See MFPartTypes.h)

virtual TMCArray<TMCRect>* MCCOMAPI IMFPart::GetVisibleRectsInWindow | ( | boolean | fullyVisibleOnly = `true` | ) | `[pure virtual]`

Creates and returns a TMCArray<TMCRect> which describe the visible rectangles in the parent window

Parameters:

  | fullyVisibleOnly | If true, restricts the array to fully-visible windows only.

Returns:
  A pointer to the array generated. Don't forget to free it when finished.

virtual const TMCString* MCCOMAPI IMFPart::GetWebLink | ( |  | ) | const`[pure virtual]`

Returns the url associated with a part, null if there is none

virtual void MCCOMAPI IMFPart::ImmediateUpdate | ( | boolean | useDoubleBuffer = `false`,
|  | const TMCRect * | inBounds = `nil` |
| ) |  |  | `[pure virtual]`

Immediately causes a redraw of this Part. Use this sparingly - only when constant redraw and interactivity are needed. Otherwise, just Invalidate.

Parameters:

  | useDoubleBuffer | If true, uses a buffered graphics context to draw
  | inBounds | A rectangle specifying the clip bounds to update. If nil, updates the whole part.

virtual void MCCOMAPI IMFPart::Invalidate | ( | const TMCRect & | invalRect | ) | `[pure virtual]`

Invalidates a portion of the Part, so it will be redrawn on the next UI redraw.

Parameters:

  | invalRect | TMCRect giving coordinates of the rectangle to invalidate

virtual void MCCOMAPI IMFPart::Invalidate | ( |  | ) | `[pure virtual]`

Invalidates the Part, so it will be redrawn on the next UI redraw.

virtual boolean MCCOMAPI IMFPart::IsChildOf | ( | const IMFPart * | inPart | ) | const`[pure virtual]`

Given a Part, determines if this Part is a child of the given Part. If it is the same part, it returns true.

Parameters:

  | inPart | The Part to check for parentage of this Part

Returns:
  True if this part is a child of inPart.

virtual boolean MCCOMAPI IMFPart::IsInMultiValueMode | ( |  | ) | const`[pure virtual]`

Returns true if the multiple values mode is on.

virtual boolean MCCOMAPI IMFPart::IsShowing | ( |  | ) | const`[pure virtual]`

Returns:
  True if the Part is Showing.

virtual boolean MCCOMAPI IMFPart::IsValueUndefined | ( |  | ) | const`[pure virtual]`

Returns true when the multiple values mode is on and different values have been set.

virtual void MCCOMAPI IMFPart::LocalToBaseWindow | ( | TMCRect & | ioWindowRect | ) | const`[pure virtual]`

Converts a TMCRect from local to base window coordinate space

Parameters:

  | ioWindowRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::LocalToBaseWindow | ( | TMCPoint & | ioWindowPoint | ) | const`[pure virtual]`

Converts a TMCPoint from local to base window coordinate space

Parameters:

  | ioWindowPoint | The point to be converted

virtual void MCCOMAPI IMFPart::LocalToParent | ( | TMCRect & | ioParentRect | ) | const`[pure virtual]`

Converts a TMCRect from local to parent coordinate space

Parameters:

  | ioParentRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::LocalToParent | ( | TMCPoint & | ioParentPoint | ) | const`[pure virtual]`

Converts a TMCPoint from local to parent coordinate space

Parameters:

  | ioParentPoint | The point to be converted

virtual void MCCOMAPI IMFPart::LocalToScreen | ( | TMCRect & | ioWindowRect | ) | const`[pure virtual]`

Converts a TMCRect from local to screen/global coordinate space

Parameters:

  | ioWindowRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::LocalToScreen | ( | TMCPoint & | ioWindowPoint | ) | const`[pure virtual]`

Converts a TMCPoint from local to screen/global coordinate space

Parameters:

  | ioWindowPoint | The point to be converted

virtual void MCCOMAPI IMFPart::LocalToWindow | ( | TMCRect & | ioWindowRect | ) | const`[pure virtual]`

Converts a TMCRect from local to window coordinate space

Parameters:

  | ioWindowRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::LocalToWindow | ( | TMCPoint & | ioWindowPoint | ) | const`[pure virtual]`

Converts a TMCPoint from local to window coordinate space

Parameters:

  | ioWindowPoint | The point to be converted

virtual void MCCOMAPI IMFPart::ParentToLocal | ( | TMCRect & | ioParentRect | ) | const`[pure virtual]`

Converts a TMCRect from parent to local coordinate space

Parameters:

  | ioParentRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::ParentToLocal | ( | TMCPoint & | ioParentPoint | ) | const`[pure virtual]`

Converts a TMCPoint from parent to local coordinate space

Parameters:

  | ioParentPoint | The point to be converted

virtual void MCCOMAPI IMFPart::ProcessUpdates | ( | const TMCRect & | inUpdateRect = `TMCRect::kInvalid` | ) | `[pure virtual]`

Call when you need to process updates in the platform window that contains this Part.

Parameters:

  | inUpdateRect | Default value will update the entire platform window. Use other values to specify the sub rectangle of the Part to be updated, specified in the Part's local space.

virtual void MCCOMAPI IMFPart::ProcessUpdatesPart | ( | boolean | inPostAction = `false` | ) | `[pure virtual]`

Call when you need to process updates only on the Part's sub-rect in the platform window that contains this Part.

Parameters:

  | inPostAction | when true, an update action is posted that will be executed later (can be useful to validate caches)

virtual void MCCOMAPI IMFPart::RemoveFromParent | ( |  | ) | `[pure virtual]`

Removes this Part as child of its parent Part.

virtual void MCCOMAPI IMFPart::ResignAsResponder | ( |  | ) | `[pure virtual]`

If this Part is the first responder, sets the first responder to be this Part's base window. If this Part is the first window responder of its base window, sets the first windor responder to the window

Note:
  You only need to call this if you are doing unusual stuff like removing a slider from a part by hand. Otherwise, the resignation is automatically made in SelfPrepareToDestroy.

virtual void MCCOMAPI IMFPart::ScreenToLocal | ( | TMCRect & | ioWindowRect | ) | const`[pure virtual]`

Converts a TMCRect from screen/global to local coordinate space

Parameters:

  | ioWindowRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::ScreenToLocal | ( | TMCPoint & | ioWindowPoint | ) | const`[pure virtual]`

Converts a TMCPoint from screen/global to local coordinate space

Parameters:

  | ioWindowPoint | The point to be converted

virtual void MCCOMAPI IMFPart::SelfDraw | ( | IMCGraphicContext * | inGraphicContext,
|  | const TMCRect & | inUpdateBBox |
| ) |  |  | `[pure virtual]`

Draws the part (use this if in a part extension you want the part (not the extension) to draw itself).

Parameters:

  | inGraphicContext | Graphic context to use for drawing operations.
  | inUpdateBBox | Clipping rectangle for update - use to avoid redrawing more pixels than necessary

virtual TMFEventResult MCCOMAPI IMFPart::SelfMouseDown | ( | const TMCPoint & | inWhere,
|  | const TMCPlatformEvent & | inEvent |
| ) |  |  | `[pure virtual]`

Handles a mouse down event within the Part's bounds (use this if in a part extension you want the part (not the extension) to handle the mouse down).

Parameters:

  | inWhere | point in local coordinates of the mouse down
  | inEvent | event information (like click count and modifier keys)

Returns:
  A bitfield (see TMFEventResult). While the previous version returned a boolean, generally you should now return TMFEventResult(result, result).

virtual void MCCOMAPI IMFPart::SelfMouseEntering | ( | const TMCPoint & | inWhere,
|  | const TMCModifiers & | inModifiers |
| ) |  |  | `[pure virtual]`

Function called when the mouse enters the Part. Use when the Part needs to handle mouseovers, for example to change appearance when the mouse is over it.

Parameters:

  | inWhere | Point in local coordinate space where the cursor is
  | inModifiers | Bitfield (see TMCModifiers) listing the modifier keys currently active.

virtual void MCCOMAPI IMFPart::SelfMouseLeaving | ( | const TMCModifiers & | inModifiers | ) | `[pure virtual]`

Function called when the mouse leaves the Part. Use when the Part needs to handle mouseovers, for example to change appearance when the mouse is over it.

Parameters:

  | inModifiers | Bitfield (see TMCModifiers) listing the modifier keys currently active.

virtual void MCCOMAPI IMFPart::SelfMouseStillInside | ( | const TMCPoint & | inWhere,
|  | const TMCModifiers & | inModifiers |
| ) |  |  | `[pure virtual]`

Function called when the mouse tracks within the Part.

Parameters:

  | inWhere | Point in local coordinate space where the cursor is
  | inModifiers | Bitfield (see TMCModifiers) listing the modifier keys currently active.

virtual void MCCOMAPI IMFPart::SelfTrackDragAndDropEntering | ( | const TMCPoint & | inWhere,
|  | const TMFDragFlavors & | inOfferedTypeList |
| ) |  |  | `[pure virtual]`

Function called when the mouse enters the Part during a drag and drop.

Parameters:

  | inWhere | Point in local coordinate space where the cursor is
  | inOfferedTypeList | Flavors offered by the current drop candiadate.

virtual void MCCOMAPI IMFPart::SelfTrackDragAndDropLeaving | ( | const TMFDragFlavors & | inOfferedTypeList | ) | `[pure virtual]`

Function called when the mouse leaves the Part during a drag and drop.

Parameters:

  | inOfferedTypeList | Flavors offered by the current drop candiadate.

virtual void MCCOMAPI IMFPart::SelfTrackDragAndDropStillInside | ( | const TMCPoint & | inWhere,
|  | const TMFDragFlavors & | inOfferedTypeList |
| ) |  |  | `[pure virtual]`

Function called when the mouse track within the Part during a drag and drop.

Parameters:

  | inWhere | Point in local coordinate space where the cursor is
  | inOfferedTypeList | Flavors offered by the current drop candiadate.

virtual void MCCOMAPI IMFPart::SetAttribute | ( | const IMFAttribute & | inAttribute | ) | `[pure virtual]`

Sets the Attribute of the Part. This is used to set several properties of the Part, with some type checking. Note: This is currently only implemented by slider parts.

See also:
  IMFAttribute

Parameters:

  | inAttribute | The IMFAttribute to set on this Part

virtual void MCCOMAPI IMFPart::SetBoundsInParent | ( | const TMCRect & | inBounds,
|  | boolean | invalidate = `true`,
|  | boolean | notify = `false` |
| ) |  |  | `[pure virtual]`

Sets the size and position of the Part in parent coordinate space. This function does NOT take size and position constraints into account.

Parameters:

  | inBounds | TMCRect specifying the new bounds in parent coordinate space
  | invalidate | If true, invalidates the Part
  | notify | If true, notifies the parent Part of the bounds change

virtual void MCCOMAPI IMFPart::SetCursor | ( | MFCursorID | inCursorID | ) | `[pure virtual]`

Sets the Cursor ID to use when the mouse is in the Part, and changes the cursor to that ID immediately.

Parameters:

  | inCursorID | The Cursor ID

virtual void MCCOMAPI IMFPart::SetCursorID | ( | MFCursorID | inCursorID | ) | `[pure virtual]`

Sets the Cursor ID to use when the mouse is in the Part.

Parameters:

  | inCursorID | The Cursor ID

virtual void MCCOMAPI IMFPart::SetEraseBack | ( | boolean | inEraseBack | ) | `[pure virtual]`

Sets whether or not to erase the background behind the Part before drawing the Part.

Parameters:

  | inEraseBack | If true, the Part will erase the background before drawing.

virtual void MCCOMAPI IMFPart::SetExcludeFromDoubleBuffer | ( | boolean | inExclude | ) | `[pure virtual]`

Sets whether or not to exclude this Part from double buffering.

Parameters:

  | inExclude | If true, the Part will be accumulated and drawn non-double-buffered.

virtual void MCCOMAPI IMFPart::SetIMFPartID | ( | IDType | partID | ) | `[pure virtual]`

Sets the Part ID. This function is identical to SetPartID, and should not be called. It may be removed in future versions of the SDK.

Parameters:

  | partID | The Part ID to set.

virtual void MCCOMAPI IMFPart::SetIsGroup | ( | boolean | isGroup | ) | `[pure virtual]`

Sets whether this part is a group or not.

virtual void MCCOMAPI IMFPart::SetIsOpaque | ( | boolean | isOpaque | ) | `[pure virtual]`

Sets the overall opacity of the Part over its full bounds.

Parameters:

  | isOpaque | If true, the Part is fully opaque.

virtual void MCCOMAPI IMFPart::SetMultiValueMode | ( | boolean | activateMultiValueMode | ) | `[pure virtual]`

Activates the multiple values mode. In that mode, the part can be asked to represent several values at the same time (eg both true and false)

virtual void MCCOMAPI IMFPart::SetMustFullyInvalidate | ( | boolean | inMust | ) | `[pure virtual]`

Sets whether or not we can optimize by only invalidating the new boundaries of the Part when resizing or moving the Part.

Parameters:

  | inMust | If true, the Part must be fully invalidated when changed.

virtual void MCCOMAPI IMFPart::SetOpacityKind | ( | EOpacityKind | inOpacityKind | ) | `[pure virtual]`

Sets the type of opacity used by the Part. Parts can be fully, partially, or not opaque.

See also:
  EOpacityKind

Parameters:

  | inOpacityKind |

virtual void MCCOMAPI IMFPart::SetPartID | ( | MFPartID | inPartID | ) | `[pure virtual]`

Sets the Part ID

Parameters:

  | inPartID | The Part ID to set

virtual void MCCOMAPI IMFPart::SetPositionInParent | ( | const TMCPoint & | inPosition,
|  | boolean | inInvalidate,
|  | boolean | inNotify |
| ) |  |  | `[pure virtual]`

Sets the Part's position in its parent Part. Performs a call to SetBoundsInParent() with the new position.

Parameters:

  | inPosition | TMCPoint specifying the new position in parent coordinate space
  | inInvalidate | If true, invalidates the Part
  | inNotify | If true, notifies the parent Part of the bounds change

virtual void MCCOMAPI IMFPart::SetShown | ( | boolean | inShown,
|  | boolean | setChilds = `false` |
| ) |  |  | `[pure virtual]`

Sets whether or not this Part is Showing.

Parameters:

  | inShown | If true, the Part is Showing
  | setChilds | If true, recursively sets the children of this Part to inShown

virtual void MCCOMAPI IMFPart::SetSize | ( | const TMCPoint & | inSize,
|  | boolean | inInvalidate,
|  | boolean | inNotify |
| ) |  |  | `[pure virtual]`

Resizes this Part. Performs a call to SetBoundsInParent() with the new size.

Parameters:

  | inSize | TMCPoint specifying the new size for the Part
  | inInvalidate | If true, invalidates the Part
  | inNotify | If true, notifies the parent Part of the bounds change

virtual void MCCOMAPI IMFPart::SetTextStyle | ( | ETextStyle | inTextStyle,
|  | const TMCString & | inFontName,
|  | uint16 | inSize,
|  | uint16 | inFace |
| ) |  |  | `[pure virtual]`

Sets the text style for the Part. This is not used by every Part, but for those that do, this determines the type of text to draw in the Part by default. You can either pass a defined ETextStyle (kUIFont_Medium for example) and null values for the following three parameters, or you can pass kUseTextStyle and then specify a custom text style using the following three parameters.

Parameters:

  | inTextStyle | Either kUseTextStyle or one of the predefined ETextStyles
  | inFontName | A string with the name of the font to use
  | inSize | Point size of the font to use
  | inFace | Style of font to use (Normal, bold, italic, etc. See IMCFont.h)

virtual void MCCOMAPI IMFPart::SetToolTipString | ( | const TMCString & | str | ) | `[pure virtual]`

Set the tool tip string. In order to use this method Tool Tip Base should be kNoToolTip

Parameters:

  | str | The new tool tip

virtual void MCCOMAPI IMFPart::SetValue | ( | const void * | inValue,
|  | MFPartValueType | inValueType,
|  | boolean | inInvalidate,
|  | boolean | inNotify |
| ) |  |  | `[pure virtual]`

SetValue is used to set a value associated with the Part.

Parameters:

  | inValue | Pointer to the value being passed
  | inValueType | Specifies the type of the value passed (See MFPartTypes.h)
  | inInvalidate | If true, invalidates the Part
  | inNotify | If true, notifies the parent that the Part value has changed

virtual boolean MCCOMAPI IMFPart::SetWantsToValidateCaches | ( |  | ) | `[pure virtual]`

Tells the Part's parent window to call this Part's ValidateCaches() method before the next UI redraw.

Returns:
  False if we are not in a window.

virtual void MCCOMAPI IMFPart::SetWantsVisibleRegion | ( | boolean | inWantsVisibleRegion | ) | `[pure virtual]`

Sets whether or not the Part cares about visible regions - an advanced topic generally not required for normal UI work.

Parameters:

  | inWantsVisibleRegion | If true, the Part wants to have visible regions calculated

virtual void MCCOMAPI IMFPart::SetWebLink | ( | const TMCString & | inLink | ) | `[pure virtual]`

Sets the url associated with a part.

Parameters:

  | inLink | the url to use when open a web browser as the user clicks on the part.

virtual void MCCOMAPI IMFPart::SwapOrientation | ( | boolean | inHorizontal | ) | `[pure virtual]`

Swaps the orientation of the part

Parameters:

  | inHorizontal | whether or not the new orientation will be horizontal (only used for toolbars, the part swaps anyways)

virtual void MCCOMAPI IMFPart::UndefineValue | ( |  | ) | `[pure virtual]`

Activates multivalue mode if needed and marks the value as undefined.

virtual void MCCOMAPI IMFPart::WindowToLocal | ( | TMCRect & | ioWindowRect | ) | const`[pure virtual]`

Converts a TMCRect from window to local coordinate space

Parameters:

  | ioWindowRect | The rectangle to be converted

virtual void MCCOMAPI IMFPart::WindowToLocal | ( | TMCPoint & | ioWindowPoint | ) | const`[pure virtual]`

Converts a TMCPoint from window to local coordinate space

Parameters:

  | ioWindowPoint | The point to be converted

The documentation for this struct was generated from the following file:

- IMFPart.h